<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/9/6
 * Time: 14:45
 */

namespace kwy\login\service;


use kwy\login\exception\PasswordErrorException;
use kwy\login\exception\UnLoginException;
use Lcobucci\JWT\Builder;
use Lcobucci\JWT\Parser;
use Lcobucci\JWT\Signer\Hmac\Sha256;
use think\facade\Config;
use think\facade\Log;

class VipLogin
{
    private $vip_info;

    private $key='useragentdengluloginaawonima';

    /**
     * 设置JWT加密秘钥
     * @param string $key
     */
    public function setKey($key=''){
        $this->key = $key;
    }

    public function login($vip_info){
        #jwt设置
        $signer = new Sha256();
        $token = (new Builder())->setIssuer('vip_token')
            ->setIssuedAt(time())
            ->set('vip_info',json_encode($vip_info))
            ->set('time_key',time())
            ->sign($signer,Config::get('jwt.kwy_vip_login','yp2dja32dfa932hfadfj23sdf23'))
            ->getToken();
        $token_string = $token->__toString();

        return $token_string;
    }

    /**
     * 获取登录会员信息
     * @param string $token
     * @return mixed
     * @throws UnLoginException
     */
    public function getVipInfo(string $token=''){
        if (empty($this->vip_info)){
            if (empty($token)){
                $token=request()->server('http_token');
            }
            try{
                $jwt = (new Parser())->parse($token);
                if(!$jwt->verify(new Sha256(),Config::get('jwt.kwy_vip_login','yp2dja32dfa932hfadfj23sdf23'))){
                    throw new UnLoginException('会员未登录');
                }
                ## 登录过期判断，下期处理
//                $old_time = $jwt->getClaim('time_key');
//                $expire = intval(time()-$old_time);
//                if($expire > 7*24*3600){
//                    throw new UnLoginException("登录已过期，请重新登录");
//                }
                $vip_info_json = $jwt->getClaim('vip_info');
                $vip_info = json_decode($vip_info_json,true);
            }catch (\Exception $e){
                Log::log('error',$e->getMessage().'|jwt_token='.$token);
                throw new UnLoginException('会员未登录');
            }
            $this->vip_info = $vip_info;
        }
        return $this->vip_info;
    }
}